from asyncio.log import logger
from typing import List
import sys
from netmiko import ConnectHandler, BaseConnection
from pandas import read_csv, DataFrame
from config import host_file, command_file, output_file, log_fomartter
import logging
import re

logger = logging.getLogger(__name__)
logger.setLevel(logging.INFO)
fomartter = logging.Formatter(log_fomartter)


stream = logging.StreamHandler()
stream.setFormatter(fomartter)
logger.addHandler(stream)

file = logging.FileHandler(output_file)
file.setFormatter(fomartter)
logger.addHandler(file)


def run_commands(connection: BaseConnection, df_command: DataFrame):    
    for index, row in df_command.iterrows():
        command = str(row['command']).strip()    
        expect_string = str(row['expect_string'])
        if(str(row['command']).strip()!=""):
            """ if(command.strip()=="#enable_mode"):
                logger.info("Entering enable mode")
                connection.enable()
            elif(command.strip()=="#end_enable_mode"):
                logger.info("Exiting enable mode")
                connection.exit_enable_mode()
            elif(command.strip()=="#config_mode"):
                logger.info("Entering config mode")               
                connection.config_mode()
            elif(command.strip()=="#end_config_mode"):
                logger.info("Exiting config mode")
                connection.exit_config_mode()
            else: """
            output= connection.send_command(command, strip_prompt=False, strip_command=False, expect_string=expect_string)
            logger.info(output)


df_host = read_csv(host_file)   
df_command = read_csv(command_file)
with open(output_file, 'w') as file_output:  
    file_output.truncate()
    sys.stdout = file_output
    for index, row in df_host.iterrows():
        logger.info("Connect to host: " + str(row['host']))
        try:
            with ConnectHandler(**row) as device_connect:
                logger.info("Connect to host : " + str(row['host']) + " success !")
                run_commands(device_connect, df_command)                
        except Exception as ex:
            logger.info(ex)
    sys.stdout.close()
